##############################################################################
#
# Copyright (C) 1998 Daniel Lopez
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

proc AddHeading {path index title}  {


frame $path.head_$index -borderwidth 2 -height 60 -width 370 
message $path.head_$index.message -text "$title" -borderwidth 1 -relief flat  -foreground blue -width 300


grid $path.head_$index.message -column 0 -row 0 -columnspan 1 -rowspan 1 -ipadx 2 \
        -ipady 4 -padx 4 
pack $path.head_$index


}



proc AddContainerChild.File { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]

  
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370
message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat  -anchor w -width 100

entry $path.dir_$directive.entry
button $path.dir_$directive.open -image images(images,file) -command "

set types {
    {{Apache Configuration Files}        {.conf}     {}  }
    {{All Files}        *             {} }
}
set filename \[tk_getOpenFile -filetypes \$types\]

if {\$filename != \"\"} {
$path.dir_$directive.entry delete 0 end
if \[regexp {\ } \$filename\] {$path.dir_$directive.entry insert 0 \\\"\$filename\\\" } else { $path.dir_$directive.entry insert 0 \$filename }
}

"

 
pack $path.dir_$directive.message -side left -padx 2
pack $path.dir_$directive.open -padx 10 -side right
pack $path.dir_$directive.entry -side right

pack $path.dir_$directive -fill x


}

proc AddContainerChild.Directory { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]
  
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370
message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat  -anchor w -width 100

entry $path.dir_$directive.entry 

button $path.dir_$directive.open -image images(images,file) 

 
pack $path.dir_$directive.message -side left
pack $path.dir_$directive.open -padx 10 -side right
pack $path.dir_$directive.entry -side right

pack $path.dir_$directive  -fill x



}

proc AddContainerChild.unknown { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]
  
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370
message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat  -anchor w -width 350

text $path.dir_$directive.text



 
pack $path.dir_$directive.message
pack $path.dir_$directive.text 

pack $path.dir_$directive  -fill x



}

proc AddContainerChild.Boolean { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]
set values "{on} {off}"

  
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370
message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat -anchor w -width 150

eval tk_optionMenu $path.dir_$directive.choice com(globals,choice,$path.dir_$directive) {UNSET} $values
 

pack $path.dir_$directive.message   -side left 
pack $path.dir_$directive.choice   -side right
pack $path.dir_$directive -fill x



}

proc AddContainerChild.Boolean2 { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]

 

frame $path.dir_$directive -borderwidth 2 -height 38 -width 370 


checkbutton $path.dir_$directive.checkbutton -text $text  -pady 4 -variable com(globals,checkbuttons,$path.dir_$directive)

pack  $path.dir_$directive.checkbutton -side left

pack $path.dir_$directive -fill x

return [$path.dir_$directive.checkbutton cget -height]

}

proc AddContainerChild.Number { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]

  
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370 

message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat -anchor w -width 150
entry $path.dir_$directive.entry -width 8
 
pack $path.dir_$directive.message  -side left 
pack $path.dir_$directive.entry  -side right

pack $path.dir_$directive -fill x


}



proc AddContainerChild.Address { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]

  
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370
message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat -anchor w -width 150

entry $path.dir_$directive.entry -width 20
 
pack $path.dir_$directive.message  -side left  
pack $path.dir_$directive.entry   -side right

pack $path.dir_$directive -fill x


}



proc AddContainerChild.Domain { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]


  
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370
message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat  -anchor w -width 150

entry $path.dir_$directive.entry -width 20
 
pack $path.dir_$directive.message  -side left 
pack $path.dir_$directive.entry  -side right

pack $path.dir_$directive -fill x

}


proc AddContainerChild.Email { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]
 
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370
message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat -anchor w -width 150

entry $path.dir_$directive.entry -width 20
 

pack $path.dir_$directive.message   -side left 
pack $path.dir_$directive.entry   -side right
pack $path.dir_$directive -fill x

}

proc AddContainerChild.Choice { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]
set values [lindex $com(modules,$module,drctvs,$directive,description) 2]

  
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370
message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat -anchor w -width 150

eval tk_optionMenu $path.dir_$directive.choice com(globals,choice,$path.dir_$directive) {UNSET} $values
 

pack $path.dir_$directive.message   -side left 
pack $path.dir_$directive.choice   -side right
pack $path.dir_$directive -fill x



}


proc AddContainerChild.String { path module directive } {
global com

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]
set tam [lindex $com(modules,$module,drctvs,$directive,description) 2]

 
 

frame $path.dir_$directive -borderwidth 2 -height 60 -width 370
message $path.dir_$directive.message -text "$text" -borderwidth 1 -relief flat -anchor w -width 150

entry $path.dir_$directive.entry -width $tam 
 
pack $path.dir_$directive.message   -side left 
pack $path.dir_$directive.entry   -side right

pack $path.dir_$directive -fill x



}

proc AddContainerChild.List { path module directive } {

global com


set sintaxlist ""

foreach sintax $com(modules,$module,drctvs,$directive,sintaxlist) {

set tmp "modules,$module,drctvs,$directive,sintax,$sintax"
lappend sintaxlist " \{ $sintax \} \{ $com($tmp,info) \} \{ $com($tmp,description) \} \{ $com($tmp,info) \}" 

}

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]

 

frame $path.dir_$directive   -height 200 -width 370 
frame $path.dir_$directive.frm  -height 100 -width 370 

set kk "$path.dir_$directive.frm.sy set"

listbox $path.dir_$directive.frm.lb   -yscrollcommand $kk -bg white -height 5

bind $path.dir_$directive.frm.lb   <ButtonRelease-1> {
      global widget
	global com
    }

bind $path.dir_$directive.frm.lb   <Double-Button-1> "

$path.dir_$directive.frm.frm.edit invoke

    "

set kk "$path.dir_$directive.frm.lb yview"

scrollbar $path.dir_$directive.frm.sy -command $kk  -orient vert 

message $path.dir_$directive.frm.message -text "$text" -borderwidth 1 -relief flat -anchor center  -width  300


frame $path.dir_$directive.frm.frm -width 300 

pack [button $path.dir_$directive.frm.frm.add  -image images(images,add) \
							     -command " dialog_add \"$sintaxlist\"; if \[ expr \[string compare \$result {} \] != 0 \]  \{ $path.dir_$directive.frm.lb insert end \$result  \}" ] -side left -padx 2


pack [button $path.dir_$directive.frm.frm.del  -image images(images,del)\
	-command "
		
		foreach s \[$path.dir_$directive.frm.lb  curselection]\ \{

		$path.dir_$directive.frm.lb delete \$s

		\}

			"

		] -side left -padx 2

pack [button $path.dir_$directive.frm.frm.edit -image images(images,edit) -command "

		set s \[$path.dir_$directive.frm.lb  curselection]\ 
		
		if \[ expr \[string compare \$s {} \] != 0 \] \{

		set ss \[$path.dir_$directive.frm.lb  get \$s  ]\ 

		$path.dir_$directive.frm.lb delete \$s

		dialog_edit \"$sintaxlist\"  \$ss

		if \[ expr \[string compare \$result {} \] != 0 \]  \{ $path.dir_$directive.frm.lb insert \$s \$result  \} \}

"

] -side left -padx 2


pack $path.dir_$directive.frm.frm  -side bottom  -padx 75 -pady 8 -fill x

pack $path.dir_$directive.frm.message -side top -pady 3 -fill x


pack $path.dir_$directive.frm.sy -side right -fill y
pack $path.dir_$directive.frm.lb -side left -anchor center  -fill y -fill x -expand 1

pack $path.dir_$directive.frm  -anchor center
pack $path.dir_$directive -fill x -pady 10



}

proc AddContainerChild.List2 { path module directive } {

global com


set sintaxlist ""

foreach sintax $com(modules,$module,drctvs,$directive,sintaxlist) {

set tmp "modules,$module,drctvs,$directive,sintax,$sintax"
lappend sintaxlist " \{ $sintax \} \{ $com($tmp,info) \} \{ $com($tmp,description) \} \{ $com($tmp,info) \}" 

}

set text [lindex $com(modules,$module,drctvs,$directive,description) 1]

 

frame $path.dir_$directive   -height 200 -width 370 
frame $path.dir_$directive.frm  -height 100 -width 370 

set kk "$path.dir_$directive.frm.sy set"

listbox $path.dir_$directive.frm.lb   -yscrollcommand $kk -bg white -height 5

bind $path.dir_$directive.frm.lb   <ButtonRelease-1> {
      global widget
	global com
    }

bind $path.dir_$directive.frm.lb   <Double-Button-1> "

$path.dir_$directive.frm.frm.edit invoke

    "

set kk "$path.dir_$directive.frm.lb yview"

scrollbar $path.dir_$directive.frm.sy -command $kk  -orient vert 

message $path.dir_$directive.frm.message -text "$text" -borderwidth 1 -relief flat -anchor center -width  300


frame $path.dir_$directive.frm.frm -width 300 

pack [button $path.dir_$directive.frm.frm.add  -image images(images,add) \
							     -command " dialog_add \"$sintaxlist\"; if \[ expr \[string compare \$result {} \] != 0 \]  \{ $path.dir_$directive.frm.lb insert end \$result  \}" ] -side left -padx 2


pack [button $path.dir_$directive.frm.frm.del  -image images(images,del)\
	-command "
		
		foreach s \[$path.dir_$directive.frm.lb  curselection]\ \{

		$path.dir_$directive.frm.lb delete \$s

		\}

			"

		] -side left -padx 2

pack [button $path.dir_$directive.frm.frm.edit -image images(images,edit) -command "

		set s \[$path.dir_$directive.frm.lb  curselection]\ 
		
		if \[ expr \[string compare \$s {} \] != 0 \] \{

		set ss \[$path.dir_$directive.frm.lb  get \$s  ]\ 

		$path.dir_$directive.frm.lb delete \$s

		dialog_edit \"$sintaxlist\"  \$ss

		if \[ expr \[string compare \$result {} \] != 0 \]  \{ $path.dir_$directive.frm.lb insert \$s \$result  \} \}

"

] -side left -padx 2


pack $path.dir_$directive.frm.frm  -side bottom  -padx 75 -pady 8 -fill x

pack $path.dir_$directive.frm.message -side top -pady 3 -fill x


pack $path.dir_$directive.frm.sy -side right -fill y
pack $path.dir_$directive.frm.lb -side left -anchor center  -fill y -fill x -expand 1

pack $path.dir_$directive.frm  -anchor center
pack $path.dir_$directive -fill x -pady 10



}


proc CreateAllContainers {} {

global com

foreach scp "sconfig vhost dirs location" {


	for "set i 0" {$i < [llength $com(layout,scope,$scp,part,list)]} "incr i" {

	CreateContainer $scp $i

	}


}

}


proc ShowContainer {scope part} {

global widget
global com

set temp $scope
append temp _cv

set actual $com(layout,scope,$scope,part,actual)

$widget($temp) delete tag.p_$actual

update idletasks

#Aqui distinguir entre  el nombre que aparece en el listbox y el que debe de tener


$widget($temp) create window 0 0 -window $widget($temp).p_$part -anchor nw -tag tag.p_$part -width 310


set com(layout,scope,$scope,part,actual) $part

update idletasks

set k [winfo height $widget($temp).p_$part]
$widget($temp) configure -scrollregion "0 0 377 $k"

set com(globals,scope,$scope,status) enabled
}

proc ShowBlank {scope part} {

global widget
global com

set temp $scope
append temp _cv

set actual $com(layout,scope,$scope,part,actual)
catch [$widget($temp) delete tag.p_$actual]

update idletasks

set com(layout,scope,$scope,part,actual) $part

update idletasks

$widget($temp) configure -scrollregion "0 0 0 0"

set com(globals,scope,$scope,status) disabled
}
