##############################################################################
#
# Copyright (C) 1998 Daniel Lopez
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

proc dialog_add { description }  {

toplevel .dialogadd
grab .dialogadd
wm title .dialogadd "Add"

set w .dialogadd

pack  [ message $w.description -text "Use the following sintax:"  -borderwidth 1 -relief flat  -aspect 800  -foreground Blue ] -fill x 

set i 0

foreach sintax $description {

	set sintaxname  [lindex $sintax 0]
	set sintaxinfo  [lindex $sintax 1]
	set sintaxdescription [lindex $sintax 2]

	pack [ message $w.sintax$i -text "$sintaxdescription" -borderwidth 1 -relief flat -width 400 -anchor w] -fill x 


	incr i


			
}

#Aqui puede haber varias cosas dependiendo de si es file, etc. De momento lo dejamos

pack [entry $w.entry -width 32] -padx 16 -pady 10  

frame $w.f

button $w.f.ok -text "Ok" -command "set result \[$w.entry get\]; destroy $w" 
button $w.f.cancel -text "Cancel" -command " set result {}; destroy $w "

pack $w.f.ok -side left
pack $w.f.cancel -side right
pack $w.f -fill x

focus .dialogadd.entry

tkwait  window .dialogadd
}

proc dialog_edit { description default}  {

toplevel .dialogedit
grab .dialogedit
wm title .dialogedit "Edit"

set w .dialogedit

pack  [ message $w.description -text "Use the following sintax:"  -borderwidth 1 -relief flat  -fg Blue -width 400 -anchor w] -fill x 

set i 0


foreach sintax $description {

	set sintaxname  [lindex $sintax 0]
	set sintaxinfo  [lindex $sintax 1]
	set sintaxdescription [lindex $sintax 2]

	pack [ message $w.sintax$i -text "$sintaxdescription"  -borderwidth 1 -relief flat  -aspect 800 ] -fill x


	incr i
	# Tomar decision aqui sobre si esa version sirve para lo que queremos

			
}

#Aqui puede haber varias cosas dependiendo de si es file, etc. De momento lo dejamos

entry $w.entry  -width 32 
$w.entry delete 0 end
$w.entry insert 0 $default

pack  $w.entry -padx 16 -pady 10


frame $w.f


button $w.f.ok -text "Ok" -command "set result \[$w.entry get\]; destroy $w"

global result
set result $default
button $w.f.cancel -text "Cancel" -command "destroy $w "

pack $w.f.ok -side left
pack $w.f.cancel -side right
pack $w.f -fill x


focus .dialogedit.entry

tkwait window .dialogedit
}


proc AddVhost { }  {

toplevel .addvhost
grab .addvhost
wm title .addvhost "Add new virtual host"

set w .addvhost

pack  [ message $w.description -text "Insert the address of the new virtual host"  -borderwidth 1 -relief flat  -aspect 800  -foreground Blue ] -fill x 


pack [entry $w.entry -width 32] -padx 16 -pady 10  

frame $w.f

button $w.f.ok -text "Ok" -command "set result \[$w.entry get\]; destroy $w" 
button $w.f.cancel -text "Cancel" -command " set result {}; destroy $w "

pack $w.f.ok -side left
pack $w.f.cancel -side right
pack $w.f -fill x

focus .addvhost.entry

tkwait  window .addvhost
}


proc EditVhost {default}  {

toplevel .editvhost
grab .editvhost
wm title .editvhost "Edit Virtual Host Settings"

set w .editvhost

pack  [ message $w.description -text "Enter the new name for the virtual host"  -borderwidth 1 -relief flat  -fg Blue -width 400 -anchor w] -fill x 

entry $w.entry  -width 32 
$w.entry delete 0 end
$w.entry insert 0 $default

pack  $w.entry -padx 16 -pady 10


frame $w.f


button $w.f.ok -text "Ok" -command "set result \[$w.entry get\]; destroy $w"
global result
set result $default
button $w.f.cancel -text "Cancel" -command "destroy $w "

pack $w.f.ok -side left
pack $w.f.cancel -side right
pack $w.f -fill x


focus .editvhost.entry

tkwait window .editvhost
}


proc AddDir { vhost }  {

toplevel .adddir
grab .adddir
wm title .adddir "Add new dir for $vhost"

set w .adddir

pack  [ message $w.description -text "Insert the new dir for $vhost"  -borderwidth 1 -relief flat  -aspect 800  -foreground Blue ] -fill x 


pack [entry $w.entry -width 32] -padx 16 -pady 10  

frame $w.f

button $w.f.ok -text "Ok" -command "set result \[$w.entry get\]; destroy $w" 
button $w.f.cancel -text "Cancel" -command " set result {}; destroy $w "

pack $w.f.ok -side left
pack $w.f.cancel -side right
pack $w.f -fill x

focus .adddir.entry

tkwait  window .adddir
}

proc AddLocation { vhost }  {

toplevel .addvhost
grab .addvhost
wm title .addvhost "Add new location for $vhost"

set w .addvhost

pack  [ message $w.description -text "Insert the new location for $vhost"  -borderwidth 1 -relief flat  -aspect 800  -foreground Blue ] -fill x 


pack [entry $w.entry -width 32] -padx 16 -pady 10  

frame $w.f

button $w.f.ok -text "Ok" -command "set result \[$w.entry get\]; destroy $w" 
button $w.f.cancel -text "Cancel" -command " set result {}; destroy $w "

pack $w.f.ok -side left
pack $w.f.cancel -side right
pack $w.f -fill x

focus .addvhost.entry

tkwait  window .addvhost
}
