##############################################################################
#
# Copyright (C) 1998 Daniel Lopez
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#######
#
# Procedimiento que lee los webs almacenados y sus direcciones, para conectarse en el futuro
#
# Input: file 
# Output: 
######


proc Parser { file } {

global com

set fich [open $file]

while {[expr ![eof $fich]]} {
	gets $fich dato
	AddWeb [lindex $dato 0] [lindex $dato 1] [lindex $dato 2] [lindex $dato 3]
	}

close $fich
}


#########
#
# Adds a Web to the web database
#
# Inputs: name address port comments
# Outputs:
#
#######

proc AddWeb { name address port comments } {

global com

lappend com(webs,list) [list $name]
set com(webs,$name,address) $address
set com(webs,$name,comments) $comments
set com(webs,$name,port) $port

}

#########
#
# Updates Web lists
#
# To-do: First delete existing entries (if any)
#
##########


proc UpdateWebList {} {
global com
global widget

set limit [llength $com(webs,list)]

for {set i 0} {$i<$limit} {incr i} {
	$widget(weblist) insert end [join [lindex $com(webs,list) $i]]
	}

}


#########
#
# Update Part list
#
#
##########

proc UpdatePartList { scope } {
global com
global widget

$widget($scope,parts_list) delete 0 end

set limit [llength $com(layout,scope,$scope,part,list)]

for {set i 0} {$i<$limit} {incr i} {

$widget($scope,parts_list) insert end [join [lindex $com(layout,scope,$scope,part,list) $i]]
	}

}


proc UpdateVhostList {} {

global com
global widget

$widget(dirs,vhost_list) delete 0 end
$widget(location,vhost_list) delete 0 end
$widget(vhost,vhost_list) delete 0 end

set limit [llength $com(data,vhost,list)]

$widget(dirs,vhost_list) insert end "Main Server"
$widget(location,vhost_list) insert end "Main Server"
for {set i 0} {$i<$limit} {incr i} {

$widget(vhost,vhost_list) insert end [join [lindex $com(data,vhost,list) $i]]
$widget(dirs,vhost_list) insert end [join [lindex $com(data,vhost,list) $i]]
$widget(location,vhost_list) insert end [join [lindex $com(data,vhost,list) $i]]
	}

}


proc UpdateDirList { vhost } {

global com
global widget
$widget(dirs,dirs_list) delete 0 end

set limit [llength $com(data,vhost,name,$vhost,dirs,list)]

$widget(dirs,dirs_list) delete 0 end

for {set i 0} {$i<$limit} {incr i} {

$widget(dirs,dirs_list) insert end [join [lindex $com(data,vhost,name,$vhost,dirs,list) $i]]

	}

}

proc UpdateLocationList { vhost } {

global com
global widget

$widget(location,location_list) delete 0 end
set limit [llength $com(data,vhost,name,$vhost,location,list)]

$widget(location,location_list) delete 0 end

for {set i 0} {$i<$limit} {incr i} {

$widget(location,location_list) insert end [join [lindex $com(data,vhost,name,$vhost,location,list) $i]]

	}

}


#############

proc ReadModulesDescription {path } {


global com

set fich [open "$path/modlist.ccf"]

while {[expr ![eof $fich]]} {
	gets $fich dato
	switch [lindex $dato 0] {
   	module {
	set temp [lindex "[lindex $dato 1]" 2]
	ReadModule "$path/$temp"}
       	default {}
	}	
	}

close $fich


}



proc ReadModule {file} {
global com

set fich [open $file]

gets $fich dato



set modname [lindex $dato 1]
AddModule $modname
puts  $com(globals,errorlog) "nombre $modname"

while {[expr ![eof $fich]]} {

gets $fich dato

switch [lindex $dato 0] {
	directive {
	AddDirective  $modname $fich}
	default {}
	}
}

close $fich

}

proc AddModule { module } {
global com

lappend com(modules,list) [list $module]

}

proc AddDirective {module fich} {

global com

while {[expr ![eof $fich]]} {

gets $fich dato


switch [lindex $dato 0] {

	name 		{set directive [lindex $dato 1]
	                 set platform [lindex $dato 3] 
			 set compat [lindex $dato 2]
			 
			 if [expr [string compare $compat {}] == 0] {set compat ".*"}
			 if [expr [string compare $platform {}] == 0] {set platform ".*"}
			 
			 if "[regexp $compat $com(globals,version)] & [regexp  $platform $com(globals,platform)]" {
			 
			lappend com(modules,$module,drctvs,list) [list $directive]
			set com(modules,$module,drctvs,$directive,sintaxlist) ""
			set com(modules,$module,drctvs,$directive,write) $directive
			#default write == name

			} else {
			puts  $com(globals,errorlog) " $directive dropped due to not compatible with version or platform"
			gets $fich dato
			
			while { [expr [string compare [lindex $dato 0] {/directive} ]!= 0] } {
			gets $fich dato
			}
	
	
			
			}}

	write		{set write [lindex $dato 1]
			set com(modules,$module,drctvs,$directive,write) $write
			}


	object 	{	
			set type [list [lindex $dato 1]]

			set com(modules,$module,drctvs,$directive,type) $type
			set com(modules,$module,drctvs,$directive,description)  "[lindex $dato 2]"
			lappend com(dir-types,$type) $directive
			lappend com(dir-types-lowercase,$type) [string tolower $directive]
		}

	sintax      {
			set sintaxname [lindex $dato 1]
			set sintaxinfo [lindex $dato 2]
			set sintaxdescription [lindex $dato 3]

			lappend com(modules,$module,drctvs,$directive,sintaxlist) [list $sintaxname]
			set com(modules,$module,drctvs,$directive,sintax,$sintaxname,info) $sintaxinfo
			set com(modules,$module,drctvs,$directive,sintax,$sintaxname,description) $sintaxdescription
			}

	scope		{set com(modules,$module,drctvs,$directive,scope) [list [lindex $dato 1]]}

	help		{}

	/directive  { 
	
	return 1
		
	}
}
}
return 0

}



proc AddModule { module } {
global com

lappend com(modules,list) [list $module]

}



proc ReadLayouts {file} {

global com

set fich [open $file]

while {[expr ![eof $fich]]} {

gets $fich dato

switch [lindex $dato 0] {
	layout {AddLayout [lindex $dato 1] $fich}
	default {}
	}
}

close $fich

}



proc AddLayout {scope fich} {

global com

while {[expr ![eof $fich]]} {

gets $fich dato

switch [lindex $dato 0] {

    part    { AddPart $scope [lindex $dato 1] $fich }
    /layout  {return 1}
		
	}
}

return 1
}


proc AddPart {scope part fich} {

global com


lappend com(layout,scope,$scope,part,list) [list $part]

set position [llength $com(layout,scope,$scope,part,list)]

incr position -1

while {[expr ![eof $fich]]} {

gets $fich dato

switch [lindex $dato 0] {

	title 	{
			set title [lindex $dato 1] 
			lappend com(layout,scope,$scope,part,$position,titles) $title
			AddTitle $scope $position $title $fich 
			}

	/part      {return 1}
		
	}
}

}

proc AddTitle {scope part title fich} {

global com

while {[expr ![eof $fich]]} {

gets $fich dato

switch [lindex $dato 0] {

	/title {return 1}
	default {

#Aqui quizas un chequeo para incluir o no modules dependiendo de SO 

	lappend com(layout,scope,$scope,part,$part,title,$title,directives)   [lindex $dato 0]
	}
	
	}
}

return 1
}



#######
#
# Create Module Scheme: Crea y devuelve la plantilla que utilizaremos luego en los
# frames de servers y main
# 
#
#######

proc CreateContainer {scope part} {

global widget
global com


set temp $scope

append temp _cv


#catch [destroy $widget($temp).p_$part]

set path $widget($temp).p_$part

frame $path -width 310

lappend com(containers,list) [list $scope.$part]

set com(containers,$scope.$part,path) $path


set i 0
foreach title "$com(layout,scope,$scope,part,$part,titles)" {

		AddHeading $path $i "$title"


foreach pair  "$com(layout,scope,$scope,part,$part,title,$title,directives)"  {
		
		# We include it in the list
		lappend com(containers,$scope.$part,childs,list) [list $pair]

		set module [lindex $pair 0] 
		set directive [lindex $pair 1] 
		# We request the object to be created
		set type $com(modules,$module,drctvs,$directive,type)

		AddContainerChild.$type $path $module $directive 

			}
	
incr i
}


}




proc PurgePart {scope part} {

global widget
global com

# We check now that the directives that are in the layout do exist
# (maybe a module was not loaded or a directive did not exist for a
# certain version of apache)


set i 0
foreach title "$com(layout,scope,$scope,part,$part,titles)" {

set  d 0
foreach pair  "$com(layout,scope,$scope,part,$part,title,$title,directives)"  {
			
		set module [lindex $pair 0] 
		set directive [lindex $pair 1] 

		# We see if the variable exists
		#
    if  "![info exists com(modules,$module,drctvs,$directive,type)]" {

puts  $com(globals,errorlog) "In scope $scope and part $part and title $title the directive $directive has been drop"

set com(layout,scope,$scope,part,$part,title,$title,directives) [lreplace $com(layout,scope,$scope,part,$part,title,$title,directives) $d $d]

incr d -1
}

incr d	
}

if [expr [llength $com(layout,scope,$scope,part,$part,title,$title,directives)] == 0] { 

unset  com(layout,scope,$scope,part,$part,title,$title,directives)

puts $com(globals,errorlog) "In scope $scope and part $part the title $title has been drop"
set com(layout,scope,$scope,part,$part,titles) [lreplace $com(layout,scope,$scope,part,$part,titles) $i $i]


}
	
incr i

}
}




proc PurgeAll {} {

global com

foreach scp "sconfig vhost dirs location" {

    set l  [llength $com(layout,scope,$scp,part,list)]

    for "set i 0" {$i < $l} "incr i" {

       PurgePart  $scp $i

    }


}

}







